clang 8.0.0

Static Public Member Functions | Friends | List of all members
clang::OMPTaskwaitDirective Class Reference

This represents '#pragma omp taskwait' directive. More...

`#include "clang/AST/StmtOpenMP.h"`

Inheritance diagram for clang::OMPTaskwaitDirective:
[legend]
Collaboration diagram for clang::OMPTaskwaitDirective:
[legend]

## Static Public Member Functions
static OMPTaskwaitDirective * | Create (const ASTContext &C, SourceLocation StartLoc, SourceLocation EndLoc)
| Creates directive. More...
static OMPTaskwaitDirective * | CreateEmpty (const ASTContext &C, EmptyShell)
| Creates an empty directive. More...
static bool | classof (const Stmt *T)
Static Public Member Functions inherited from clang::OMPExecutableDirective
template<typename SpecificClause >
static llvm::iterator_range< specific_clause_iterator< SpecificClause > > | getClausesOfKind (ArrayRef< OMPClause *> Clauses)
static bool | classof (const Stmt *S)
Static Public Member Functions inherited from clang::Stmt
static void | addStmtClass (const StmtClass s)
static void | EnableStatistics ()
static void | PrintStats ()

## Friends
class | ASTStmtReader

## Additional Inherited Members
Public Types inherited from clang::Stmt
enum | StmtClass { NoStmtClass = 0 }
using | child_iterator = StmtIterator
| Child Iterators: All subclasses must implement 'children' to permit easy iteration over the substatements/subexpessions of an AST node. More...
using | const_child_iterator = ConstStmtIterator
using | child_range = llvm::iterator_range< child_iterator >
using | const_child_range = llvm::iterator_range< const_child_iterator >
Public Member Functions inherited from clang::OMPExecutableDirective
template<typename SpecificClause >
llvm::iterator_range< specific_clause_iterator< SpecificClause > > | getClausesOfKind () const
template<typename SpecificClause >
const SpecificClause * | getSingleClause () const
| Gets a single clause of the specified kind associated with the current directive iff there is only one clause of this kind (and assertion is fired if there is more than one clause is associated with the directive). More...
template<typename SpecificClause >
bool | hasClausesOfKind () const
| Returns true if the current directive has one or more clauses of a specific kind. More...
SourceLocation | getBeginLoc () const
| Returns starting location of directive kind. More...
SourceLocation | getEndLoc () const
| Returns ending location of directive. More...
void | setLocStart (SourceLocation Loc)
| Set starting location of directive kind. More...
void | setLocEnd (SourceLocation Loc)
| Set ending location of directive. More...
unsigned | getNumClauses () const
| Get number of clauses. More...
OMPClause * | getClause (unsigned i) const
| Returns specified clause. More...
bool | hasAssociatedStmt () const
| Returns true if directive has associated statement. More...
const Stmt * | getAssociatedStmt () const
| Returns statement associated with the directive. More...
Stmt * | getAssociatedStmt ()
const CapturedStmt * | getCapturedStmt (OpenMPDirectiveKind RegionKind) const
| Returns the captured statement associated with the component region within the (combined) directive. More...
CapturedStmt * | getInnermostCapturedStmt ()
| Get innermost captured statement for the construct. More...
const CapturedStmt * | getInnermostCapturedStmt () const
OpenMPDirectiveKind | getDirectiveKind () const
child_range | children ()
ArrayRef< OMPClause * > | clauses ()
ArrayRef< OMPClause * > | clauses () const
Public Member Functions inherited from clang::Stmt
void * | operator new (size_t bytes, const ASTContext &C, unsigned alignment=8)
void * | operator new (size_t bytes, const ASTContext *C, unsigned alignment=8)
void * | operator new (size_t bytes, void *mem) noexcept
void | operator delete (void *, const ASTContext &, unsigned) noexcept
void | operator delete (void *, const ASTContext *, unsigned) noexcept
void | operator delete (void *, size_t) noexcept
void | operator delete (void *, void *) noexcept
| Stmt (StmtClass SC)
StmtClass | getStmtClass () const
const char * | getStmtClassName () const
SourceRange | getSourceRange () const LLVM_READONLY
| SourceLocation tokens are not useful in isolation - they are low level value objects created/interpreted by SourceManager. More...
SourceLocation | getBeginLoc () const LLVM_READONLY
SourceLocation | getEndLoc () const LLVM_READONLY
void | dump () const
| Dumps the specified AST fragment and all subtrees to `llvm::errs()`. More...
void | dump (SourceManager &SM) const
void | dump (raw_ostream &OS, SourceManager &SM) const
void | dump (raw_ostream &OS) const
int64_t | getID (const ASTContext &Context) const
void | dumpColor () const
| dumpColor - same as dump(), but forces color highlighting. More...
void | dumpPretty (const ASTContext &Context) const
| dumpPretty/printPretty - These two methods do a "pretty print" of the AST back to its original source language syntax. More...
void | printPretty (raw_ostream &OS, PrinterHelper *Helper, const PrintingPolicy &Policy, unsigned Indentation=0, StringRef NewlineSymbol="\, const ASTContext *Context=nullptr) const
void | viewAST () const
| viewAST - Visualize an AST rooted at this Stmt* using GraphViz. More...
Stmt * | IgnoreImplicit ()
| Skip past any implicit AST nodes which might surround this statement, such as ExprWithCleanups or ImplicitCastExpr nodes. More...
const Stmt * | IgnoreImplicit () const
Stmt * | IgnoreContainers (bool IgnoreCaptured=false)
| Skip no-op (attributed, compound) container stmts and skip captured stmt at the top, if IgnoreCaptured is true. More...
const Stmt * | IgnoreContainers (bool IgnoreCaptured=false) const
const Stmt * | stripLabelLikeStatements () const
| Strip off all label-like statements. More...
Stmt * | stripLabelLikeStatements ()
child_range | children ()
const_child_range | children () const
child_iterator | child_begin ()
child_iterator | child_end ()
const_child_iterator | child_begin () const
const_child_iterator | child_end () const
void | Profile (llvm::FoldingSetNodeID &ID, const ASTContext &Context, bool Canonical) const
| Produce a unique representation of the given statement. More...
void | ProcessODRHash (llvm::FoldingSetNodeID &ID, ODRHash &Hash) const
| Calculate a unique representation for a statement that is stable across compiler invocations. More...
Protected Types inherited from clang::Stmt
enum | { NumStmtBits = 8 }
enum | { NumExprBits = NumStmtBits + 9 }
enum | APFloatSemantics { IEEEhalf, IEEEsingle, IEEEdouble, x87DoubleExtended, IEEEquad, PPCDoubleDouble }
enum | { NumCallExprBits = 32 }
enum | { NumOverloadExprBits = NumExprBits + 1 }
Protected Member Functions inherited from clang::OMPExecutableDirective
template<typename T >
| OMPExecutableDirective (const T *, StmtClass SC, OpenMPDirectiveKind K, SourceLocation StartLoc, SourceLocation EndLoc, unsigned NumClauses, unsigned NumChildren)
| Build instance of directive of class K. More...
void | setClauses (ArrayRef< OMPClause *> Clauses)
| Sets the list of variables for this clause. More...
void | setAssociatedStmt (Stmt *S)
| Set the associated statement for the directive. More...
Protected Member Functions inherited from clang::Stmt
void * | operator new (size_t bytes) noexcept
void | operator delete (void *data) noexcept
| Stmt (StmtClass SC, EmptyShell)
| Construct an empty statement. More...
Protected Attributes inherited from clang::Stmt
union {
StmtBitfields StmtBits
NullStmtBitfields NullStmtBits
CompoundStmtBitfields CompoundStmtBits
LabelStmtBitfields LabelStmtBits
AttributedStmtBitfields AttributedStmtBits
IfStmtBitfields IfStmtBits
SwitchStmtBitfields SwitchStmtBits
WhileStmtBitfields WhileStmtBits
DoStmtBitfields DoStmtBits
ForStmtBitfields ForStmtBits
GotoStmtBitfields GotoStmtBits
ContinueStmtBitfields ContinueStmtBits
BreakStmtBitfields BreakStmtBits
ReturnStmtBitfields ReturnStmtBits
SwitchCaseBitfields SwitchCaseBits
ExprBitfields ExprBits
PredefinedExprBitfields PredefinedExprBits
DeclRefExprBitfields DeclRefExprBits
FloatingLiteralBitfields FloatingLiteralBits
StringLiteralBitfields StringLiteralBits
CharacterLiteralBitfields CharacterLiteralBits
UnaryOperatorBitfields UnaryOperatorBits
UnaryExprOrTypeTraitExprBitfields UnaryExprOrTypeTraitExprBits
ArraySubscriptExprBitfields ArraySubscriptExprBits
CallExprBitfields CallExprBits
MemberExprBitfields MemberExprBits
CastExprBitfields CastExprBits
BinaryOperatorBitfields BinaryOperatorBits
InitListExprBitfields InitListExprBits
ParenListExprBitfields ParenListExprBits
PseudoObjectExprBitfields PseudoObjectExprBits
CXXOperatorCallExprBitfields CXXOperatorCallExprBits
CXXBoolLiteralExprBitfields CXXBoolLiteralExprBits
CXXNullPtrLiteralExprBitfields CXXNullPtrLiteralExprBits
CXXThisExprBitfields CXXThisExprBits
CXXThrowExprBitfields CXXThrowExprBits
CXXDefaultArgExprBitfields CXXDefaultArgExprBits
CXXDefaultInitExprBitfields CXXDefaultInitExprBits
CXXScalarValueInitExprBitfields CXXScalarValueInitExprBits
CXXNewExprBitfields CXXNewExprBits
CXXDeleteExprBitfields CXXDeleteExprBits
TypeTraitExprBitfields TypeTraitExprBits
DependentScopeDeclRefExprBitfields DependentScopeDeclRefExprBits
CXXConstructExprBitfields CXXConstructExprBits
ExprWithCleanupsBitfields ExprWithCleanupsBits
CXXUnresolvedConstructExprBitfields CXXUnresolvedConstructExprBits
CXXDependentScopeMemberExprBitfields CXXDependentScopeMemberExprBits
OverloadExprBitfields OverloadExprBits
UnresolvedLookupExprBitfields UnresolvedLookupExprBits
UnresolvedMemberExprBitfields UnresolvedMemberExprBits
CXXNoexceptExprBitfields CXXNoexceptExprBits
SubstNonTypeTemplateParmExprBitfields SubstNonTypeTemplateParmExprBits
CoawaitExprBitfields CoawaitBits
ObjCIndirectCopyRestoreExprBitfields ObjCIndirectCopyRestoreExprBits
OpaqueValueExprBitfields OpaqueValueExprBits
}; |

## Detailed Description

This represents '#pragma omp taskwait' directive.

#pragma omp taskwait

Definition at line 1927 of file StmtOpenMP.h.

## Member Function Documentation

## ◆ classof()

static bool clang::OMPTaskwaitDirective::classof | ( | const Stmt * | T | ) |
| inline static

Definition at line 1960 of file StmtOpenMP.h.

References clang::Stmt::getStmtClass().

## ◆ Create()

OMPTaskwaitDirective * OMPTaskwaitDirective::Create | ( | const ASTContext & | C,
|  | SourceLocation | StartLoc,
|  | SourceLocation | EndLoc
| ) |  |
| static

Creates directive.

Parameters

  C | AST context.
  StartLoc | Starting location of the directive kind.
  EndLoc | Ending Location of the directive.

Definition at line 511 of file StmtOpenMP.cpp.

References clang::ASTContext::Allocate().

Referenced by clang::Sema::ActOnOpenMPTaskwaitDirective().

## ◆ CreateEmpty()

OMPTaskwaitDirective * OMPTaskwaitDirective::CreateEmpty | ( | const ASTContext & | C,
|  | EmptyShell |
| ) |  |
| static

Creates an empty directive.

Parameters

  C | AST context.

Definition at line 519 of file StmtOpenMP.cpp.

References clang::ASTContext::Allocate().

## Friends And Related Function Documentation

## ◆ ASTStmtReader

friend class ASTStmtReader
| friend

Definition at line 1928 of file StmtOpenMP.h.

The documentation for this class was generated from the following files:

- include/clang/AST/StmtOpenMP.h
- lib/AST/StmtOpenMP.cpp